<?php

namespace App\Enums;

use App\Filament\Support\CheerfulNotification;
use App\Traits\Enum\WithComment;
use App\Traits\Enum\WithValue;
use Filament\Support\Contracts\HasColor;
use Filament\Support\Contracts\HasLabel;

enum DataChangeDecision: int implements HasColor, HasLabel
{
    use WithComment, WithValue;

    case APPROVED = 1;
    case REJECTED = 2;

    public function getLabel(): ?string
    {
        return match ($this) {
            self::APPROVED => CheerfulNotification::getByKey('enum.data_change_decision.approved'),
            self::REJECTED => CheerfulNotification::getByKey('enum.data_change_decision.rejected'),
        };
    }

    public function getColor(): string|array|null
    {
        return match ($this) {
            self::APPROVED => 'success',
            self::REJECTED => 'danger',
        };
    }

    public static function options(): array
    {
        return collect(self::cases())
            ->mapWithKeys(fn ($case) => [$case->value => $case->getLabel()])
            ->toArray();
    }
}
